(* This program tests the public functions of complex.ml *)

open Complex;;

let number_of_test_values = 100;;
let random_init_salt = 12;;
let maximum_value = 1000.0;;
let one_to_one_hundred = Util.list_range 1 number_of_test_values;;

let random_complex_numbers1 = 
  List.map 
    (function x -> {re = Random.float maximum_value;
		    im = Random.float maximum_value})
                        one_to_one_hundred;;

let random_complex_numbers2 = 
  List.map 
    (function x -> {re = Random.float maximum_value;
		    im = Random.float maximum_value})
                        one_to_one_hundred;;


let summed = List.map2 (&+&) random_complex_numbers1 random_complex_numbers2;;
let subtracted1 = List.map2 (&-&) summed random_complex_numbers2;;
let subtracted2 = List.map2 (&-&) subtracted1 random_complex_numbers1;;
let magnitudes = List.map mod_square subtracted2;;

let very_small x = (abs_float x) < 0.0001;;

let addition_subtraction = List.for_all very_small magnitudes;;

(* still need to test conjugates, inverses??, multiplication,
   maybe division also *)

(* tests *)

let ts = [
  ("addition",addition_subtraction)
] ;;  (* haven't written any yet *)

let main () = Regression.regression ts;;
main () ;;

  
  
