(* This program tests the public functions of recognize_numbers.ml *)

let number_of_tests = 100;;
let random_init_salt = 12;;
let one_to_one_hundred = Util.list_range 1 100;;

let random_integers = List.map (function x -> Random.int 1000)
                                          one_to_one_hundred;;
let strings_of_integers = List.map string_of_int random_integers;;
let random_floats = List.map 
                     (function x -> Random.float 1000.0)
                        one_to_one_hundred;;
let strings_of_floats = List.map string_of_float random_floats;;

let make_argumentor arg = "input:" ^ (string_of_int arg);;
let input_argumentors = List.map make_argumentor random_integers;;

(* tests *)
let is_integer_ok = List.for_all Recognize_numbers.is_integer 
                        strings_of_integers;;
let is_real_ok = List.for_all Recognize_numbers.is_real 
                        strings_of_floats;;
let is_an_input_argumentor_ok =
   List.for_all Recognize_numbers.is_an_input_argumentor input_argumentors;;
let which_input_argumentor_ok =
   (List.map (Recognize_numbers.which_input_argumentor) input_argumentors)
     =
   random_integers;;

let ts = [
  ("is_integer",is_integer_ok);
  ("is_real",is_real_ok);
  ("is_an_input_argumentor",is_an_input_argumentor_ok);
  ("which_input_argumentor",which_input_argumentor_ok)];;
	  
let main () = Regression.regression ts;;
main () ;;

  
  
