set gatecount 0

proc PlaceGate {canvas_name screen_x screen_y {coordinates_are_screen 1}} {
  if {$coordinates_are_screen} {
    set x [.$canvas_name canvasx $screen_x]
    set y [.$canvas_name canvasy $screen_y]
  } else {
    set x $screen_x
    set y $screen_y
  }
  upvar #0 gatecount this
  incr this
  global gate inputs outputs gate_inp gate_outp gate_x gate_y gate_type
  set gate_inp($this) {}
  set gate_outp($this) {}
  upvar #0 $gate.gif im
  menubutton .$canvas_name.gate$this -menu .$canvas_name.gate$this.m -image $im
  menu .$canvas_name.gate$this.m
  .$canvas_name.gate$this.m add command -label "Delete" -command "RemoveGate $this"
  global attribute attribute_default attribute_value
  if {[info exists attribute($gate)]} {
	.$canvas_name.gate$this.m add separator
	.$canvas_name.gate$this.m add command -label "Modify $attribute($gate)" \
           -command "modifyAttribute $this"
        set attribute_value($this) $attribute_default($gate)
        frame .$canvas_name.$this-frame -borderwidth 0
        label .$canvas_name.$this-frame.name -text "$attribute($gate)=" -bd 0
        label .$canvas_name.$this-frame.value -textvariable attribute_value($this)                 -bd 0
        pack .$canvas_name.$this-frame.name .$canvas_name.$this-frame.value -side left -padx 0m
        global attribute_frame_id
        set attribute_frame_id($this) \
            [.$canvas_name create window [expr $x+38] $y -window .$canvas_name.$this-frame]
     }
  if {$inputs($gate) > 0} { .$canvas_name.gate$this.m add separator }
  for {set i 1} {$i <= $inputs($gate)} {incr i} {
     .$canvas_name.gate$this.m add command -label "Input $i" -command "connect_input $this $i"
     lappend gate_inp($this) _
  }
  if {$outputs($gate) > 0} { .$canvas_name.gate$this.m add separator }
  for {set i 1} {$i <= $outputs($gate)} {incr i} {
     .$canvas_name.gate$this.m add command -label "Output $i" -command "output_make $this $i"
     lappend gate_outp($this) _
  }
  global canvas_id_of_gate gate_canvas
  set canvas_id_of_gate($this) \
        [.$canvas_name create window $x $y -window .$canvas_name.gate$this]

# Make bindings to overide menu operation,  so that we can move
  bind .$canvas_name.gate$this <Control-Button-1> \
        ".$canvas_name.gate$this configure -state disabled"
  bind .$canvas_name.gate$this <Control-B1-Motion> "GateMove $this %x %y"
  bind .$canvas_name.gate$this <ButtonRelease> \
        ".$canvas_name.gate$this configure -state normal"

# Make bindings to overide menu operation,  so that we can move
  bind .$canvas_name.gate$this <Button-2> \
        ".$canvas_name.gate$this configure -state disabled"
  bind .$canvas_name.gate$this <Control-B2-Motion> "GateMove $this %x %y"
  bind .$canvas_name.gate$this <ButtonRelease> \
        ".$canvas_name.gate$this configure -state normal"


  set gate_x($this) $x
  set gate_y($this) $y
  set gate_type($this) $gate
  set gate_canvas($this) $canvas_name
  return $this
}



proc RemoveGate {which} {
  global gate_inp gate_outp canvas_id_of_gate gate_type gate_canvas
  set which_canvas $gate_canvas($which)


  foreach g $gate_inp($which) {
    if {$g != "_"} { DeleteWire $g }
  }
  unset gate_inp($which)


  foreach g $gate_outp($which) {
    if {$g != "_"} { DeleteWire $g }
  }
  unset gate_outp($which)


  .$which_canvas delete $canvas_id_of_gate($which)
  destroy .$which_canvas.gate$which
  
  global attribute
  if [info exists attribute($gate_type($which))] {
        global attribute_frame_id
	.$which_canvas delete $attribute_frame_id($which)
        destroy .$which_canvas.$which-frame
	} 

  unset gate_type($which)
  unset gate_canvas($which)
}


proc modifyAttribute {whose} {
  set tp .attr-$whose
  if {[winfo exists $tp]} then return
  toplevel $tp
  global attribute gate_type
  wm title $tp $attribute($gate_type($whose))
  global attribute_temp attribute_value
  set attribute_temp($whose) $attribute_value($whose)
  entry $tp.e -textvariable attribute_temp($whose)
  button $tp.ok -text "OK" \
   -command "set attribute_value($whose) \$attribute_temp($whose);destroy $tp"
  button $tp.cancel -command "destroy $tp" -text "Cancel"
  pack $tp.e -side top
  pack $tp.ok -side left
  pack $tp.cancel -side right
}
 

proc ChangeGateOutput {who hcihw new_value} {
 set which [expr $hcihw-1]
 global gate_outp
 if {[llength $gate_outp($who)] <= $which} {
    error "Programming error : attempt to change non-existant node"
 }
 set gate_outp($who) [lreplace $gate_outp($who) $which $which $new_value]
}



proc ChangeGateInput {who hcihw new_value} {
 set which [expr $hcihw-1]
 global gate_inp
 if {[llength $gate_inp($who)] <= $which} {
    error "Programming error : attempt to change non-existant node"
 }
 set gate_inp($who) [lreplace $gate_inp($who) $which $which $new_value]
}


proc GetGateOutput {who hcihw} {
 set which [expr $hcihw-1]
 global gate_outp
 if {[llength $gate_outp($who)] <= $which} {
   error "Programming error : attempt to view non-existant node"
 }
 return [lindex $gate_outp($who) $which]
}



proc GetGateInput {who hcihw} {
 set which [expr $hcihw-1]
 global gate_inp
 if {[llength $gate_inp($who)] <= $which} {
   error "Programming error : attempt to view non-existant node"
 }
 return [lindex $gate_inp($who) $which]
}



proc GateMove {this screen_x screen_y} {

 global gate_canvas
 set which_canvas $gate_canvas($this)
 global canvas_id_of_gate
 set canvas_id $canvas_id_of_gate($this)

  set x [.$which_canvas canvasx $screen_x]
  set y [.$which_canvas canvasy $screen_y]

 global gate_x gate_y

 .$which_canvas coords $canvas_id $x $y
 #        [expr $x - $gate_x($this)] [expr $y - $gate_y($this)]

 set gate_x($this) $x
 set gate_y($this) $y

 global gate_inp gate_outp
 foreach g $gate_inp($this) {
   if {$g != "_"} { MoveWire $g } 
 } 
 foreach g $gate_outp($this) {
  if {$g != "_"} { MoveWire $g }
 }
 update

}



# returns 1 if b is an ancestor of a, 0 otherwise
proc IsAncestor? {a b} {
 if {$a == $b} { return 1 }
 global gate_inp wire_from_gate
 foreach g $gate_inp($a) {
      if {($g != "_") && [IsAncestor? $wire_from_gate($g) $b]} {return 1}
 } 
 return 0
}




# returns 1 if b is a descendant of a, 0 otherwise
proc IsDescendant? {a b} {
 if {$a == $b} { return 1 }
 global gate_outp wire_to_gate
 foreach g $gate_outp($a) {
      if {($g != "_") && [IsDescendant? $wire_to_gate($g) $b]} {return 1}
 } 
 return 0
}