proc OpenThings {} {
    set can_toplevel [makeCanvas]

    set filepatternlist {{{Qgol Files} *.qgl QGOL} {{All Files} *.*}}
    set filename [tk_getOpenFile -defaultextension .qgl -filetypes $filepatternlist]
    if {[string compare $filename ""] == 0} { return }

    wm title .$can_toplevel $filename
    set can "${can_toplevel}.c"
    
    set f [open $filename r]
    gets $f this_line
    puts "First line was $this_line"
    # That first line should be the hash bang magic

    gets $f this_line
    if {$this_line != "---gate.x gate.y gate.type gate.attribute---"} {
     error "Funny file format"
    }

    global gate attribute_value
    gets $f this_line
    set line_count 1
    while {$this_line != "---gate outputs---"} {
	if {$this_line == ""} {error "Problem reading file"}
	set l [split $this_line " "]
	set x [lindex $l 0] ;  set y [lindex $l 1] ;  set gate [lindex $l 2]
	set translation($line_count) [PlaceGate $can $x $y 0]
	puts "Creating $gate as $translation($line_count)"
	set val [lindex $l 3]
	if {$val != "_"} { set attribute_value($translation($line_count)) $val}
	incr line_count
	gets $f this_line
    }
    gets $f this_line
    set line_count 1
    while {![eof $f]} {
	set l [split $this_line " "]
	for {set from_socket 1} {[llength $l] != 0} {incr from_socket} {
	    set g [lindex $l 0] ;   set s [lindex $l 1]
	    if {$g != "_"} {
		puts "Creating wire from $translation($line_count),$from_socket to $translation($g),$s"
		CreateWire $translation($line_count) $from_socket $translation($g) $s
	    }
	    set l [lrange $l 2 end]
	}
	gets $f this_line
	incr line_count
    }
    close $f
}
