proc SaveThings {canvas_name} {
    set filepatternlist {{{Qgol Files} *.qgl QGOL} {{All Files} *.*}}
    set filename [tk_getSaveFile -defaultextension .qgl -filetypes $filepatternlist]
    if {[string compare $filename ""] == 0} { return }
    
    set f [open $filename w]
    global hash_bang_magic
    puts $f $hash_bang_magic
    puts $f "---gate.x gate.y gate.type gate.attribute---"
    
    set translation_count 1
    global gate_canvas gate_x gate_y gate_type attribute_value
    foreach g [array names gate_canvas] {
	if {$gate_canvas($g) != $canvas_name} continue
	if [info exists attribute_value($g)] {
	    puts $f [list $gate_x($g) $gate_y($g) $gate_type($g) $attribute_value($g)]
	} else {
	    puts $f [list $gate_x($g) $gate_y($g) $gate_type($g) _]
	}
	set translation($translation_count) $g
	set reverse_translation($g) $translation_count
	incr translation_count
    }
    
    
    
    puts $f "---gate outputs---"
    global gate_outp wire_to_gate wire_to_socket
    
    for {set g 1} {$g < $translation_count} {incr g} {
	set h $translation($g)
	set line ""
	foreach w $gate_outp($h) {
	    if {$w=="_"} {lappend line _ _ ; continue }
	    lappend line $reverse_translation($wire_to_gate($w)) $wire_to_socket($w)
	}
	puts $f $line
    }
    close $f
    exec chmod +x $filename
}
