#!/usr/bin/env wish

### Set this variable to being the directory that was created when you
### unpacked the Qgol distribution
set qgol_directory /home/greg/Personal/ScientificPapers/Thesis/Qgol/Qgol2

######################################################################

set gif_directory $qgol_directory/VisEdit/gifs
set hash_bang_magic "#!$qgol_directory/qgol3"
set qgol_lib $qgol_directory/VisEdit

proc makeButton {name x y} {
    global $name.gif gif_directory
    set im [image create photo -file $gif_directory/$name.GIF]
    set $name.gif $im
    radiobutton .buttons.f.c.$name -image $im -variable gate -value $name -indicatoron false
    .buttons.f.c create window $x $y -window .buttons.f.c.$name
}
       
set ButtonHeirarchyNumber 25
proc makeButtonHeirarchy {heirarchy namelist} {
  global ButtonHeirarchyNumber
  if {$ButtonHeirarchyNumber == 25} { 
      frame .buttons.f -bd 3 -relief sunken
      canvas .buttons.f.c -width 400 -height 400 -bd 0 
      #-scrollregion {0 0 1000 1000}
      #scale .buttons.sv -orient vertical -length 350 -showvalue false \
         \#-from 0 -to 2000 -command "y-scroll buttons.f.c" 
      #pack .buttons.sv -side right
       pack .buttons.f.c
       pack .buttons.f -side top -padx 2m -pady 2m
      #scale .buttons.sh -orient horizontal -length 350 -showvalue false \
          \#-from 0 -to 2000 -command "x-scroll buttons.f.c"
      #pack .buttons.sh
   }
   set i 20
   foreach b $namelist { 
      makeButton $b $i $ButtonHeirarchyNumber
      incr i 50
   }
   incr ButtonHeirarchyNumber 50
}


proc makeMenu {} {
  frame .buttons.menu -relief raised -borderwidth 2
  menubutton .buttons.menu.file -menu .buttons.menu.file.m -text "File"
  menu .buttons.menu.file.m
  .buttons.menu.file.m add command -label "New" -command makeCanvas
  .buttons.menu.file.m add command -label "Open" -command OpenThings
  .buttons.menu.file.m add separator
  .buttons.menu.file.m add command -label "Quit" -command exit

  menubutton .buttons.menu.edit -menu .buttons.menu.edit.m -text "Edit"
  menu .buttons.menu.edit.m
  .buttons.menu.edit.m add command -label "Undo" -state disabled
  .buttons.menu.edit.m add separator
  .buttons.menu.edit.m add command -label "Cut" -state disabled
  .buttons.menu.edit.m add command -label "Copy" -state disabled
  .buttons.menu.edit.m add command -label "Paste" -state disabled
  .buttons.menu.edit.m add command -label "Clear" -state disabled

  pack .buttons.menu.file .buttons.menu.edit -side left -padx 1m -fill y
  pack .buttons.menu -fill x -pady 2m
}

proc makeButtons {} {
  toplevel .buttons
  makeMenu
  makeButtonHeirarchy arithmetic {plus minus times quotient div mod power xamodn}
  makeButtonHeirarchy collection {entuple untuple enlist unlist split unsplit cylinder tube}
  makeButtonHeirarchy boolean {zero positive toffoli is_empty un-zero un-positive un-is_empty}
  makeButtonHeirarchy types {is_monad is_tuple is_list is_real is_complex is_integer}
  makeButtonHeirarchy untypes {un-is_monad un-is_tuple un-is_list un-is_real un-is_complex un-is_integer}
  makeButtonHeirarchy weird {cfrac unfrac source observe}
  makeButtonHeirarchy quantum {divincenzo fourier not smolin deutsch}

    global gate 
    label .buttons.selected_name -textvariable gate
    pack .buttons.selected_name
  set gate source
  wm title .buttons "Gates"
}


set canvas_count 0
proc makeCanvas {} {
   global canvas_count
   incr canvas_count
   set canvas_name $canvas_count
   toplevel .$canvas_name 
   wm title .$canvas_name "untitled $canvas_name"
   frame .$canvas_name.menubar
   menubutton .$canvas_name.menubar.file -text "File" \
           -menu .$canvas_name.menubar.file.m
   menu .$canvas_name.menubar.file.m
   .$canvas_name.menubar.file.m add command -label "Save" \
       -command "SaveThings $canvas_name.c"
   #.$canvas_name.menubar.file.m add command -label "Save as"
   .$canvas_name.menubar.file.m add command -label "Close" -command "destroy .$canvas_name"
   menubutton .$canvas_name.menubar.run -text "Run" \
           -menu .$canvas_name.menubar.run.m
   menu .$canvas_name.menubar.run.m
   .$canvas_name.menubar.run.m add command -label "Make executable" -state disabled
   .$canvas_name.menubar.run.m add command -label "View result file" -state disabled
   pack .$canvas_name.menubar -fill x
   pack .$canvas_name.menubar.file .$canvas_name.menubar.run -side left
   canvas .$canvas_name.c -width 500 -height 350 -relief sunken -bd 3 \
        -scrollregion {0 0 2000 2000}
   scale .$canvas_name.sv -orient vertical -length 350 -showvalue false \
          -from 0 -to 2000 -command "y-scroll $canvas_name.c" 
   pack .$canvas_name.sv -side right
   pack .$canvas_name.c -side top
   scale .$canvas_name.sh -orient horizontal -length 500 -showvalue false \
          -from 0 -to 2000 -command "x-scroll $canvas_name.c" 
   pack .$canvas_name.sh
   bind .$canvas_name.c <Button-1> "PlaceGate $canvas_name.c %x %y"
   for {set i 50} {$i < 2000} {incr i 50} {
     .$canvas_name.c create line $i 0 $i 2000 -fill blue
     .$canvas_name.c create line 0 $i 2000 $i -fill blue
   }
   global current_output_gate current_output_socket
   set current_output_gate($canvas_name.c) _
   set current_output_socket($canvas_name.c) _
   return $canvas_name
}


proc y-scroll {canvas_name where} { 
 .$canvas_name yview moveto [expr 1.0 * $where / 2000.0] 
}

proc x-scroll {canvas_name where} { 
 .$canvas_name xview moveto [expr 1.0 * $where / 2000.0] 
}



source $qgol_lib/GateDefs.tcl
source $qgol_lib/WireModule.tcl
source $qgol_lib/GateModule.tcl
source $qgol_lib/SaveTool.tcl  ;# Don't need 'til later but too lazy to use auto-loading
source $qgol_lib/OpenTool.tcl

proc output_make {which_gate which_socket} {
   global current_output_gate current_output_socket gate_canvas
   set which_canvas $gate_canvas($which_gate)
   set current_output_gate($which_canvas) $which_gate
   set current_output_socket($which_canvas) $which_socket
}

proc connect_input {to_gate to_socket} {
 global current_output_gate current_output_socket gate_canvas
 set which_canvas $gate_canvas($to_gate)
 if {$current_output_gate($which_canvas) == "_"} { 
    tk_dialog .dialog Oops "You need to specify an input first" error 0 OK
    return
 }
 set output_gate $current_output_gate($which_canvas)
 set output_socket $current_output_socket($which_canvas)
 if [IsAncestor? $output_gate $to_gate] {
	tk_dialog .dialog Recursive "That would produce a loop" error 0 OK
        return
 }
 if [IsDescendant? $to_gate $output_gate] {
	tk_dialog .dialog Recursive "That would produce a dloop" error 0 OK
        return
 }
        
 CreateWire $output_gate $output_socket $to_gate $to_socket

}



makeButtons
makeCanvas
wm withdraw .







