
set wire_count 0
proc CreateWire {from_gate from_socket to_gate to_socket} {
 upvar #0 wire_count this
 incr this
 global wire_canvas_id wire_from_gate wire_from_socket wire_to_gate wire_to_socket
 global wire_which_canvas gate_canvas
 
 set which_canvas $gate_canvas($from_gate)
 set wire_which_canvas($this) $which_canvas

  catch {  DeleteWire [GetGateOutput $from_gate $from_socket]  }
 ChangeGateOutput $from_gate $from_socket $this
  catch {  DeleteWire [GetGateInput $to_gate $to_socket] } 
 ChangeGateInput $to_gate $to_socket $this 

 set wire_from_gate($this) $from_gate
 set wire_from_socket($this) $from_socket
 set wire_to_gate($this) $to_gate
 set wire_to_socket($this) $to_socket

 MoveWire $this  ;# which draws it

}



proc DeleteWire {wire_num} {
 if {$wire_num=="_"} {error "Program error : attempt to delete non-existant wire"}
 global wire_canvas_id wire_from_gate wire_from_socket wire_to_gate wire_to_socket
 global wire_which_canvas 

 set which_canvas $wire_which_canvas($wire_num)
 .$which_canvas delete $wire_canvas_id($wire_num)
 
 ChangeGateInput  $wire_to_gate($wire_num)   $wire_to_socket($wire_num) _
 ChangeGateOutput $wire_from_gate($wire_num) $wire_from_socket($wire_num) _

}



proc MoveWire {which} {
 if {$which == "_"} { error "Programmer error : Attempt to move non-existant wire}
 global wire_canvas_id wire_which_canvas
 set which_canvas $wire_which_canvas($which)

 
 if {[info exists wire_canvas_id($which)]} {
	.$which_canvas delete $wire_canvas_id($which)
    }

 global wire_from_gate wire_to_gate wire_from_socket wire_to_socket
 set from_gate $wire_from_gate($which)
 set from_socket $wire_from_socket($which)
 set to_gate $wire_to_gate($which)
 set to_socket $wire_to_socket($which)

 global gate_x gate_y  gate_type
 global inputs outputs

 set from_x [expr $gate_x($from_gate) -20 + \
      [socket_position $outputs($gate_type($from_gate)) $from_socket]]
 set from_y [expr $gate_y($from_gate) + 20]

 set to_x [expr $gate_x($to_gate) -20 + \
      [socket_position $inputs($gate_type($to_gate)) $to_socket]]
 set to_y [expr $gate_y($to_gate) - 20]

 set wire_canvas_id($which) [.$which_canvas create line $from_x $from_y $to_x $to_y -arrow last -fill black -width 3]
 .$which_canvas bind $wire_canvas_id($which) <Shift-1> "DeleteWire $which"


}