#!/bin/bash

read line
while [ "$line" != "" ]
do
  line_skip1=$(echo $line | sed 's/^[^I]*Integer //')
  line_skip2=$(echo $line_skip1 | sed 's/^[^I]*Integer //')
  line_skip3=$(echo $line_skip2 | sed 's/^[^I]*Integer //')
  line_skip4=$(echo $line_skip3 | sed 's/^[^I]*Integer //')

  line_trim1=$(echo $line_skip1 | sed 's/;.*//')
  line_trim2=$(echo $line_skip2 | sed 's/;.*//')
  line_trim3=$(echo $line_skip3 | sed 's/;.*//')
  line_trim4=$(echo $line_skip4 | sed 's/}.*//')

  X=$line_trim1
  A=$line_trim2
  N=$line_trim3
  XAmodN=$line_trim4

  echo -n "($X;$A;$N;$XAmodN): "

  if [ "$A" -eq 0 ]
  then
    echo "A was equal to zero.  No useful data resulted."
    read line
    continue
  fi

  if [ "$(echo "($X^$A) % $N" | bc)" -eq 1 ]
  then
    echo -n "$X ^ $A mod $N = 1. "
  else
    echo "$X ^ $A mod $N =/= 1.  What a pity."
    read line
    continue
  fi

  if echo $A | grep -q '[02468]$'
  then
    echo -n " $A is even, "
  else
    echo " But $A is odd.  What a pity."
    read line
    continue
  fi

  RESULT=$(echo "($X^($A/2))-1" | bc)
  CONGRUENCE=$(echo "($RESULT % $N) + 1" | bc)
  if [ "$CONGRUENCE" -eq 1 ]
  then
    echo "but has a congruence with 1"
    read line
    continue
  elif [ "$CONGRUENCE" -eq "$N" ]
  then
    echo "but has a congruence with -1"
    read line
    continue
  else
    echo -n "and not congruent to -1. "
  fi
  
  TRIAL_DIVISOR1=$RESULT
  TRIAL_DIVISOR2=$N
  LAST_TRIAL=$N
  while [ "$LAST_TRIAL" -ne 0 ]
  do
    LAST_TRIAL=$(echo "$TRIAL_DIVISOR1 % $TRIAL_DIVISOR2" | bc)
    TRIAL_DIVISOR1=$TRIAL_DIVISOR2
    TRIAL_DIVISOR2=$LAST_TRIAL
  done
  echo "FACTOR: $TRIAL_DIVISOR1"
  read line
done