(* complex numbers *)

type complex = { re : float; im : float };;

let unity = { re = 1.0; im = 0.0 };;
let i = { re = 0.0; im = 1.0 };;
let zero = { re = 0.0; im = 0.0 };;

let (&+&) x y = { re = x.re +. y.re ; im = x.im +. y.im };;
let (&-&) x y = { re = x.re -. y.re ; im = x.im -. y.im };;
let (&*&) x y = { re = (x.re *. y.re -. x.im *. y.im);
		  im = (x.re *. y.im +. x.im *. y.re)};;
(* let (&<) x y = ... *) 

let show x = 
 match (x.re,x.im) with
   (_,0.0) -> string_of_float x.re
 | (_,1.0) -> (string_of_float x.re) ^ "+i"
 | (0.0,_) -> (string_of_float x.im) ^ "i"
 | (_,_) -> 
     if (x.im > 0.0) then 
        (string_of_float x.re) ^ "+" ^ (string_of_float x.im) ^ "i"
     else (string_of_float x.re) ^ (string_of_float x.im) ^ "i"
;;

let mod_square x = x.re *. x.re +. x.im *. x.im;;
let conjugate x = {re = x.re;im = ~-. (x.im)};;

let e_to_the_i theta = { re = cos theta;im = sin theta};;
let e_to_the_2_pi_i theta = e_to_the_i (2.0 *. 3.14159265358979323 *. theta);;

(* do I need an 
let inverse x = 
 let shrunk_conjugate = {re = x / magnitude, im = ~y / magnitude}

inverse :: Complex -> Complex
inverse {re = x,im = 0.0} = fromReal (1.0/x)
inverse {re = 0.0,im = y} = {re = 0.0,im = ~1.0/y}
inverse {re = x,im = y} = shrunk_conjugate
  where shrunk_conjugate = {re = x / magnitude, im = ~y / magnitude}
        magnitude = mod_square {re = x,im = y} 
*)
        
(*
instance / Complex
 where 
  (/) :: !Complex !Complex -> Complex
  (/) c1 c2 = c1 * inverse c2
*)

  
  
 
