(*  Converted from Haskell to CaML (Sun Aug 16 13:05:15 EST 1998) 
\chapter{Type}

I wonder whether I should grab {\sf stringToType} from section
\ref{stringToType} and put it in here, or whether it would be better
to overload {\sf Read}?

\section{Preliminaries}

*)
module Type where

(*

\ldots and no imports.  It stands alone.

\section{Type Definition}\label{Type definition}
*)
data Type = Monad
              | Intger Integer
              | Str     String
              | Dbl   Double
              | Boolean Bool
              | List    [Type]
              | Pair    Type Type
      deriving (Eq,Show,Ord)
(*

\section{Overloads}
*)  
instance Num Type where
  (+) Monad x = x
  (+) x Monad = x
  (+) (Intger i) (Intger j) = Intger (i+j)
  (+) (Str s) (Str t) = Str (s ++ t)
  (+) (Dbl f) (Dbl g) = Dbl (f + g)
  (+) (Boolean b) (Boolean c) = Boolean (b || c)
  (+) (List l) (List m) = List (l ++ m)
  (+) (Pair p1 p2) (Pair q1 q2) = Pair (p1 + q1) (p2 + q2)
  (+) (Intger i) (Dbl f) = Dbl ((fromInteger i)   + f)
  (+) (Dbl f) (Intger i)  = Dbl ((fromInteger i)   + f)
  (+) _ _ = error "Typing error in addition"
  (-)        Monad        x        = x
  (-)          x        Monad      = x
  (-)     (Intger i) (Intger j)  = Intger (i-j)
  (-)      (Dbl f)   (Dbl g)   = Dbl (f - g)
  (-)     (Boolean b) (Boolean c)  = Boolean (not ((not b) || (not c)))
  (-) (List _) (List _) = error "Don't know how to subtract lists"
  (-) (Pair p1 p2) (Pair q1 q2) = Pair (p1 - q1) (p2 - q2)
  (-) (Intger i) (Dbl f) = Dbl ((fromInteger i)   - f)
  (-) (Dbl f) (Intger i)  = Dbl (f - (fromInteger i))
  (-) _ _ = error "Typing error in subtraction"
  (*) Monad x = x
  (*) x Monad = x
  (*) (Intger i) (Intger j) = Intger (i * j)
  (*) (Dbl f) (Dbl g) = Dbl (f * g)
  (*) (Boolean b) (Boolean c) = Boolean (b && c)
  (*) (Pair p1 p2) (Pair q1 q2) = Pair (p1 * q1) (p2 * q2) 
  (*) (Intger i) (Dbl f) = Dbl ((fromInteger i)  * f)
  (*) (Dbl f) (Intger i)  = Dbl (f * (fromInteger i))
  (*) _ _ = error "Typing error in multiplication"
  negate (Intger a) = (Intger (negate a))
  negate (Dbl a) = (Dbl (negate a))
  negate (_) = error "Typing error in negate"
  abs (Intger a) = (Intger (abs a))
  abs (Dbl a) = (Dbl (abs a))
  abs (_) = error "Typing error in negate"
  signum (Intger a) = (Intger (signum a))
  signum (Dbl a) = (Dbl (signum a))
  signum (_) = error "Typing error in negate"
  fromInteger x = Intger (fromInteger x)
(*

*)
