(*  Converted from Haskell to CaML (Sun Aug 16 13:05:13 EST 1998) 
\chapter{Microcode}

A very tiny little module.  There are two functions defined, and two types.
\begin{description}
\item[QuantumProgramInstruction] Analagous to a classical computer instruction,
this is the building block from which programs are built.
\item[QuantumProgram]  Since there is
no branching or iteration of code,  a QuantumProgram is just a sequence
of QuantumProgramInstructions,  which will be performed in turn.
\item[runQuantum] This is {\em the} public function of this module.  It's just a wrapper for running run\_alt. It returns the observations that occurred in
the running of the program.
\item[run\_alt] Ugly name, eh?  Walks through the program deciding at each
instruction whether or not it is an observation,  and performing the
appropriate task either way.
\end{description}
\section{Datatypes}
*)

type quantumProgramInstruction = 
    { gate_type : Gatedefs.gate ;
      gate : Qprocessor.gate_operation ;
      inputs : int list;
      outputs : int list
    };;
        
type quantumProgram = quantumProgramInstruction list;;
(*

\section{Functions}

*)

let print_states_on_the_fly = 
 try 
   Sys.getenv("QGOL_PRINT_STATES") ; true 
 with  
   Not_found -> false;;


let rec run_alt program processor =
 if print_states_on_the_fly then
 prerr_endline (Qprocessor.show_processor processor)  else ();
 match program with
  [] -> ([],processor)
| instruction::instructions -> 
    match instruction.gate_type with
      (Gatedefs.Observe n) ->
	let (observation,new_processor) =
             Qprocessor.observe processor (List.hd instruction.inputs) in
	let (other_observation_sets,final_processor) = run_alt instructions new_processor in
	(((n,observation)::other_observation_sets),final_processor)
    | _ -> run_alt instructions (Qprocessor.evaluate processor instruction.gate instruction.inputs instruction.outputs);;

let runQuantum program = fst (run_alt program Qprocessor.start_processor);;

