(*  Converted from Haskell to CaML (Sun Aug 16 13:05:12 EST 1998) 
\chapter{Continued Fractions}

Trivial implementation of continued fractions. 

\section{Preliminaries}
*)
module Continued_Fractions where

open Ratio
(*

\section{The Continued\_Fraction type}
*)
newtype Continued_Fraction = Continued_Fraction [Integer]
(*

\section{Conversions}
*)
cfracToRational :: Continued_Fraction -> Rational
cfracToRational (Continued_Fraction []) = 0
cfracToRational (Continued_Fraction [x]) = x % 1
cfracToRational (Continued_Fraction [x,y]) = x % y
cfracToRational (Continued_Fraction (x:xs)) = (x * n + d) % n
   where remainder = cfracToRational (Continued_Fraction xs)
         n = numerator remainder
         d = denominator remainder

rationalToCfrac :: Rational -> Continued_Fraction
rationalToCfrac r
  | n == 0 = Continued_Fraction []
  | d == 1 = Continued_Fraction [n]
  | otherwise = Continued_Fraction ((n `div` d): (toList remainder))
 where n = numerator r
       d = denominator r
       remainder = rationalToCfrac (d % (n `mod` d))

cfrac_recip (Continued_Fraction (0:xs)) = Continued_Fraction xs
cfrac_recip (Continued_Fraction x) = Continued_Fraction (0:x)

toList :: Continued_Fraction -> [Integer]
toList (Continued_Fraction x) = x

(*

%instance toCfrac Double
% where
%  toCfrac :: !Real -> [Int]
%  toCfrac 0.0 = [0]
%  toCfrac x = [int_part:toCfrac (1.0/frac_part)]
%    where int_part = entier x
%          frac_part = x - (toReal int_part)
%          
%instance fromCfrac Real
% where
%  fromCfrac :: ![Int] -> Real
%  fromCfrac [] = abort "Empty list passed as a cfrac"
%  fromCfrac [0] = 0.0
%  fromCfrac [x:xs] = (toReal x) + (1.0/fromCfrac xs)
%  
%instance CFracable Rational
% where
%  toCfrac fraction
%   | n == 0 = [0]
%   | d == 0 = []
%   | otherwise = (n/d : toCfrac ( d % (n mod d))
%   where n = numerator fraction
%         d = denominator fraction
%  toCfrac {numerator = x, denominator = y} = 
%         [x/y: toCfrac {numerator = y,denominator = x mod y}]
%         
%instance CFracable Rational
% where
%  fromCfrac Fraction
% where 
%  fromCfrac :: ![Int] -> Fraction
%  fromCfrac [] =  one
%  fromCfrac [x] = fromInt x
%  fromCfrac [x,y:xs] = { numerator = x * p  + p` ,
%                         denominator = y * q  +  q`}
%     where f = fromCfrac [y:xs]
%           f` = fromCfrac xs
%           p = f.numerator
%           q = f.denominator
%           p` = f`.numerator
%           q` = f`.denominator
*)
