(*  Converted from Haskell to CaML (Sun Aug 16 13:05:13 EST 1998) 
\chapter{Microcode}

A very tiny little module.  There are two functions defined, and two types.
\begin{description}
\item[QuantumProgramInstruction] Analagous to a classical computer instruction,
this is the building block from which programs are built.
\item[QuantumProgram]  Since there is
no branching or iteration of code,  a QuantumProgram is just a sequence
of QuantumProgramInstructions,  which will be performed in turn.
\item[runQuantum] This is {\em the} public function of this module.  It's just a wrapper for running run\_alt. It returns the observations that occurred in
the running of the program.
\item[run\_alt] Ugly name, eh?  Walks through the program deciding at each
instruction whether or not it is an observation,  and performing the
appropriate task either way.
\end{description}
\section{Datatypes}
*)

type quantumProgramInstruction = 
    { gate_type:: Gatedefs.gate ,
      gate :: QProcessor.gate_operation , 
      inputs : int list,
      outputs :: int list,
    };;
        
type quantumProgram = quantumProgramInstruction list;;
(*

\section{Functions}

*)

runQuantum program = fst (run_alt program Qprocessor.start_processor)


run_alt program processor = match program with
  [] -> ([],processor)
| instruction::instructions -> 
    match instruction.gate_type with
      (Observe n) ->
	let (observation,new_processor) =
             Qprocessor.observe processor (head instruction.inputs) in
	let (other_observation_sets,final_processor) = run_alt instructions new_processor in
	(((observation,n)::other_observation_sets),final_processor)
    | _ -> run_alt instructions (Qprocessor.evaluate processor instruction.gate instruction.inputs instruction.outputs);;
