(*  Converted from Haskell to CaML (Sun Aug 16 13:05:14 EST 1998) 
\chapter{Qgol2}

This is the main module for the Qgol2 interpreter,  a program which
simulates quantum computations.

\section{Preliminaries}
*)
module Main where

open ReadDiagram
open Qfunc
open System
open Type
open RecognizeNumbers
open IO
open Random

(*

\section{main}
*)
main :: IO ()
main =
 do argv <- System.getArgs
    handle <- openFile (head argv) ReadMode 
    program <- ReadDiagram.readExecutable handle
    argv_as_types <- return (map stringToType (tail argv))
    random_integer_list <- randomIO (0,1000000000)
    random_real_list <- return (map (\x -> (fromInteger x) / 1000000000.0) random_integer_list)
    results <- return (evaluateQfunc program argv_as_types random_real_list)
    putStr (show results)

(*

\section{stringToType}\label{stringToType}
I should find a better place for this function.  Its aim is to find the most
constrained type it can to represent the {\sf String} as the
 (section \ref{Type definition}) program-defined type Type.

I should add in a  \verb+| Recognizenumbers.is_boolean string = Boolean (read string)+

*)
stringToType :: String -> Type
stringToType string
 | RecognizeNumbers.is_integer string = Intger (read string)
 | RecognizeNumbers.is_real string = Dbl (read string)
 | otherwise = Str string

(**)
