(*  Converted from Haskell to CaML (Sun Aug 16 13:05:14 EST 1998) 
\chapter{ReadDiagram}

\section{readConnections}

This probably looks clumsy.  Way down in \textsf{readExecutable} I do
a \textsf{getContents} on the file handle we are reading.  Clean didn't
have any such magical concept.

\textsf{getContents} makes things much easier.  Now I don't have to return
a unique-strict file object -- I just pass around a list of lines in the 
file.  (Which means I don't have to return anything inessential).

I should probably rewrite \textsf{readConnectionsSource} as some kind
of \textsf{foldr} operation (that's all it is), since the compiler
might be able to optimise that better, and it makes for more compact
code.

*)
            
              
readConnections :: String -> Integer -> CircuitDictionary -> CircuitDictionary
readConnections s id dict =
 let my_words = Util.split_words
 let  wrong_length = (length 
 | (length my_words) == 0  = dict
 | s == "" = dict
 | wrong_length = error ("What should I do with " ++ s ++ "?")
 | otherwise = readConnections_alt my_words 1 dict
  where 
    wrong_length = (length my_words) `mod` 2 == 1
    my_words = words s
    readConnections_alt :: [String] -> Integer -> CircuitDictionary -> CircuitDictionary
    readConnections_alt [] _ dict = dict
    readConnections_alt (idstr:(sockstr:others)) destSock dict =
       readConnections_alt others (destSock+1) (
            makeConnection dict (id,destSock) (read idstr, read sockstr) 
          )
    readConnections_alt (x:xs) _ _ = error "Cannot happen"

let rec readConnectionsSource contents line_num dictionary = 
  match contents with
    [] -> dictionary
  | (line::lines) -> readConnectionsSource lines (line_num+1) (readConnections line line_num dictionary)



readExecutableSource :: [String] -> Integer -> ([String],[(Gate,GateId)])
readExecutableSource [] _ = error "unexpected end of file"
readExecutableSource (_:lines) (-1) = readExecutableSource lines 0  
readExecutableSource (line:lines) line_num
 | line == "---gate.x gate.y gate.type gate.attribute---"
     = readExecutableSource lines 1
 | line == "---gate outputs---" = (lines,[])
 | otherwise = (unhandled_lines,(my_gate,line_num):other_gates)
    where 
          (unhandled_lines,other_gates) = readExecutableSource lines (line_num + 1)
          (_:(_:(arg3:(arg4:_)))) = words line
          my_gate = GateDefs.strings2gate arg3 arg4


let readline channel = try Some (input_line channel) with End_of_file -> None;;
let rec readlines channel = match (readline channel) with
    (Some l) -> l::(rdls channel)
   | None -> [];;

          
let readExecutable channel = 
 let contents = readlines channel in
 let (remaining_lines,whatever) = (readExecutableSource contents (-1)) in
 let quantum_function = readConnectionsSource remaining_lines 1 (gateDictionary.makeDictionary whatever)) in
    gateDictionary.compile quantum_function;;


(**)
