(*  Converted from Haskell to CaML (Sun Aug 16 13:05:15 EST 1998) 
     qgol_type.ml
*)
(*
module Type where
*)

(*
*)
type t = 
     Monad
   | Intger  of int
   | Str     of string
   | Dbl     of float
   | Boolean of bool
   | List    of t list
   | Pair    of (t * t);;

(*
  That was easy... now for ...

      deriving (Eq,  -- unnecessary?
                Show -- below
                Ord  -- unnecessary?
              )
 *)

let rec show x =
 match x with
   Monad -> "Monad"
 | Intger i -> "Integer " ^ (string_of_int i)
 | Str s -> "String " ^ s
 | Dbl d -> "Double " ^ (string_of_float d)
 | Boolean true -> "Boolean TRUE"
 | Boolean false-> "Boolean FALSE"
 | List l -> "List [" ^ (Util.string_join ", " (List.map show l)) ^ "]"
 | Pair (p,q) -> "Pair (" ^ (show p) ^ "," ^ (show q) ^ ")"

let rec show_list x = 
 "{" ^ (Util.string_join "; " (List.map show x)) ^ "}";;


(***********************************************************************)
(* Addition *)

let rec (%+%) left right =
 match (left,right) with
   (Monad,_) -> right
 | (_,Monad) -> left
 | (Intger i,Intger j) -> Intger (i+j)
 | (Str s,Str t) -> Str (s ^ t)
 | (Dbl f,Dbl g) -> Dbl (f +. g)
 | (Boolean b,Boolean c) -> Boolean (b || c)
 | (List l,List m) -> List (l @ m)
 | (Pair (p1,p2),Pair (q1,q2)) -> Pair (p1 %+% q1, p2 %+% q2)
 | (Intger i, Dbl f) -> Dbl ((float i) +. f)
 | (Dbl f,Intger i) -> Dbl ((float i) +. f)
 | (_,_) -> prerr_endline ("Impossible addition of " ^ 
			   (show left) ^ " with " ^
			   (show right) ^ ". Exitting.") ; exit 1
;;

(***********************************************************************)
(* Subtraction *)


let rec (%-%) left right =
 match (left,right) with
   (Monad,_) -> right
 | (_,Monad) -> left
 | (Intger i,Intger j) -> Intger (i-j)
 | (Dbl f,Dbl g) -> Dbl (f -. g)
 | (Boolean b,Boolean c) -> Boolean (not ((not b) || (not c)))
 | (Pair (p1,p2),Pair (q1,q2)) -> Pair (p1 %-% q1, p2 %-% q2)
 | (Intger i, Dbl f) -> Dbl ((float i) -. f)
 | (Dbl f,Intger i) -> Dbl (f -. (float i))
 | (_,_) -> prerr_endline ("Impossible subtraction of " ^ 
			   (show left) ^ " with " ^
			   (show right) ^ ". Exitting.") ; exit 1
;;


(* Multiplication *)


let rec (%*%) left right =
 match (left,right) with
   (Monad,_) -> right
 | (_,Monad) -> left
 | (Intger i,Intger j) -> Intger (i*j)
 | (Dbl f,Dbl g) -> Dbl (f *. g)
 | (Boolean b,Boolean c) -> Boolean (b && c)
 | (Pair (p1,p2),Pair (q1,q2)) -> Pair (p1 %*% q1, p2 %*% q2)
 | (Intger i, Dbl f) -> Dbl ((float i) *. f)
 | (Dbl f,Intger i) -> Dbl ((float i) *. f)
 | (_,_) -> prerr_endline ("Impossible addition of " ^ 
			   (show left) ^ " with " ^
			   (show right) ^ ". Exitting.") ; exit 1
;;



