(*  Converted from Haskell to CaML (Sun Aug 16 12:57:37 EST 1998) 
\chapter{RecognizeNumbers}

Despite its name,  the important stuff in this module is the
input argumentor section,  which is used by Qfunc.ml
in handling substitutions of command-line arguments values into initial parameters
to qgol functions.

*)

(* just private definitions *)
let digits =  Util.string_to_list "0123456789";;
let integrals = digits @ Util.string_to_list "+-";;
let reals = integrals @ Util.string_to_list ".eE";;

let is_integer_char chr = List.mem chr integrals;;
let is_real_char chr = List.mem chr reals;;

(* now the public ones *)
let is_integer str = List.for_all  is_integer_char (Util.string_to_list str);;
let is_real str = List.for_all  is_real_char (Util.string_to_list str);;

(*

\section{Input argumentor functions}

Have a look at section \ref{Call site substitutions}


*)


let is_an_input_argumentor str = (String.sub str 0 6) = "input:";;
let which_input_argumentor str =
    int_of_string (String.sub str 6 ((String.length str)-6));;
